<template>
  <div
    ref="el"
    class="container"
    @mousemove="handleMove"
    @mouseup="handleUp"
    @mousedown="handleDown"
    @dragover="dragover_handler"
    @drop="drop_handler"
  >
    <svg width="100%" height="100%" class="link">
      <RenderedLink v-for="(link, index) in lines" :link="link" :key="`link${index}-${link.id}`" />
    </svg>
    <RenderedBlock
      class="block"
      v-for="(node, index) in scene.blocks"
      :block="node"
      :key="`node${index}-${node.id}`"
      :options="block_options"
      @selected="nodeSelected(node.id, $event)"
      @delete="deleteBlock(node.id)"
      @edit="edit_block(node.id)"
      @linking_start="linkingStart(node, $event)"
      @linking_break="linkingBreak(node, $event)"
      @linking_stop="linkingStop(node, $event)"
    />
    <div class="column menu">
      <q-btn round push color="white" text-color="primary" icon="gps_fixed" @click="resetView" />
    </div>

    <EditDialog v-model:show="edit_dialog.show" :block="edit_dialog.block" />
  </div>
</template>

<script lang="ts">
import RenderedBlock from './Block.vue';
import RenderedLink from './Link.vue';
import EditDialog from './EditDialog.vue';
import { defineComponent, reactive, computed, ref, Ref, PropType } from 'vue';
import { getMousePosition, getSlotPosition } from './utility';
import { Scene, BlockOptions, RefinedLink, RefinedBlock } from 'src/models/workflow';
import { v4 as uuidv4 } from 'uuid';
import { create_block } from './block';
import { get_node } from './nodes';
import { errorNotification } from 'src/components/notifications';

export default defineComponent({
  components: {
    RenderedBlock,
    RenderedLink,
    EditDialog,
  },

  props: {
    dscene: {
      type: Object as PropType<Scene>,
      default: {
        nodes: [],
        blocks: [],
        links: [],
        container: {
          center: { x: 0, y: 0 },
          scale: 1,
        },
      } as Scene,
    },
  },

  setup(props) {
    const scene = computed(() => {
      return props.dscene;
    });

    const el = ref() as Ref<HTMLDivElement>;
    const edit_dialog = reactive({
      show: false,
      block: <RefinedBlock>{
        name: '',
        position: { x: 0, y: 0 },
        id: '',
        family: '',
        inputs: {},
        outputs: {},
        loggable: {},
        data: {},
      },
    });

    let action = reactive({
      linking: false,
      dragging: '',
      scrolling: false,
      selected: '',
    });

    const mouse = reactive({
      current: {
        x: 0,
        y: 0,
      },
      last: {
        x: 0,
        y: 0,
      },
    });

    const draggingLink = reactive({
      from: '',
      fromSlot: -1,
      ee: {
        x: 0,
        y: 0,
      },
    });

    const findBlock = (id: string) => scene.value.blocks.find((block) => block.id === id);
    const findLink = (id: string) => scene.value.links.find((link) => link.id === id);

    const block_options = computed((): BlockOptions => {
      return {
        center: scene.value.container.center,
        selected: action.selected,
      };
    });

    function nodeSelected(id: string, e: MouseEvent) {
      action.dragging = id;
      action.selected = id;
      mouse.last.x = e.pageX || e.clientX + document.documentElement.scrollLeft;
      mouse.last.y = e.pageY || e.clientY + document.documentElement.scrollTop;
    }

    function handleMove(e: MouseEvent) {
      if (action.linking) {
        mouse.current = getMousePosition(el.value, e);
        draggingLink.ee = mouse.current;
      } else if (action.dragging.length > 0) {
        mouse.current.x = e.pageX || e.clientX + document.documentElement.scrollLeft;
        mouse.current.y = e.pageY || e.clientY + document.documentElement.scrollTop;
        let diffX = mouse.current.x - mouse.last.x;
        let diffY = mouse.current.y - mouse.last.y;
        mouse.last = { ...mouse.current };
        moveSelectedNode(diffX, diffY);
      } else if (action.scrolling && el.value) {
        mouse.current = getMousePosition(el.value, e);
        let diffX = mouse.current.x - mouse.last.x;
        let diffY = mouse.current.y - mouse.last.y;
        mouse.last = { ...mouse.current };
        scene.value.container.center.x += diffX;
        scene.value.container.center.y += diffY;
      }
    }

    function handleUp(e: MouseEvent) {
      const target = e.target as HTMLElement;
      if (el.value.contains(target)) {
        /*
        if (typeof target.className !== 'string' || target.className.indexOf('node-input') < 0) {
        }*/
        if (typeof target.className === 'string' && target.className.indexOf('node-delete') > -1) {
          deleteBlock(action.dragging);
        }
      }
      action.dragging = '';
      action.scrolling = false;
      action.linking = false;
    }

    function handleDown(e: MouseEvent) {
      const target = e.target as HTMLElement;
      if (target === el.value || target.matches('svg, svg *')) {
        action.scrolling = true;
        mouse.last = getMousePosition(el.value, e);
        action.selected = '';
      }
    }

    function moveSelectedNode(dx: number, dy: number) {
      let index = scene.value.blocks.findIndex((item) => {
        return item.id === action.dragging;
      });
      if (index < 0) return;
      let left = scene.value.blocks[index].position.x + dx;
      let top = scene.value.blocks[index].position.y + dy;
      scene.value.blocks[index].position = { x: left, y: top };
    }

    function deleteBlock(id: string) {
      scene.value.blocks = scene.value.blocks.filter((block) => {
        return block.id !== id;
      });
      scene.value.links.forEach((link) => {
        if (link.fromBlock === id) {
          const toBlock = findBlock(link.toBlock);
          if (toBlock) toBlock.inputs[link.toSlot].active = '';
        }
      });
      scene.value.links = scene.value.links.filter((link) => {
        return link.fromBlock !== id && link.toBlock !== id;
      });
    }

    const resetView = () => {
      scene.value.container.center = { x: 0, y: 0 };
    };

    const lines = computed((): Array<RefinedLink> => {
      const lines = scene.value.links.map((link) => {
        const fromNode = findBlock(link.fromBlock);
        const toNode = findBlock(link.toBlock);
        if (!fromNode || !toNode)
          return <RefinedLink>{
            start: { x: 0, y: 0 },
            end: { x: 0, y: 0 },
            id: link.id,
          };
        const cpos = getSlotPosition(fromNode, link.fromSlot, 'output');
        const epos = getSlotPosition(toNode, link.toSlot, 'input');
        cpos.x += scene.value.container.center.x;
        cpos.y += scene.value.container.center.y;
        epos.x += scene.value.container.center.x;
        epos.y += scene.value.container.center.y;
        return <RefinedLink>{
          start: cpos,
          end: epos,
          id: link.id,
          fromBlock: fromNode.id,
          toBlock: toNode.id,
          fromSlot: link.fromSlot,
          toSlot: link.toSlot,
        };
      });
      if (action.linking) {
        const fromBlock = findBlock(draggingLink.from);
        if (!fromBlock) return lines;
        const cpos = getSlotPosition(fromBlock, draggingLink.fromSlot, 'output');
        cpos.x += scene.value.container.center.x;
        cpos.y += scene.value.container.center.y;
        lines.push({
          id: uuidv4(),
          start: cpos,
          end: draggingLink.ee,
          fromBlock: '',
          toBlock: '',
          fromSlot: draggingLink.fromSlot,
          toSlot: -1,
        } as RefinedLink);
      }
      return lines;
    });

    function linkingStart(block: RefinedBlock, slotIndex: number) {
      action.linking = true;
      draggingLink.from = block.id;
      draggingLink.fromSlot = slotIndex;
      draggingLink.ee = getSlotPosition(block, slotIndex, 'output'); //getMousePosition(el.value, e);
    }

    function linkingStop(block: RefinedBlock, index: number) {
      if (action.linking && draggingLink.from !== block.id && block.inputs[index].active === '') {
        const existed = scene.value.links.find((link) => {
          return (
            link.fromBlock === draggingLink.from &&
            link.toBlock === block.id &&
            link.fromSlot === draggingLink.fromSlot &&
            link.toSlot === index
          );
        });
        if (!existed) {
          // Check if the link is logically sound
          const fromBlock = scene.value.blocks.find((block) => block.id === draggingLink.from);
          if (!fromBlock) return;
          switch (block.family) {
            case 'testbed':
              if (fromBlock.family !== 'controller') return;
              break;
            case 'controller':
              if (fromBlock.family !== 'reference') return;
              break;
          }
          const link_id = uuidv4();
          const newLink = {
            id: link_id,
            fromBlock: draggingLink.from,
            toBlock: block.id,
            start: { x: 0, y: 0 },
            end: { x: 0, y: 0 },
            fromSlot: draggingLink.fromSlot,
            toSlot: index,
          } as RefinedLink;
          block.inputs[index].active = link_id;
          scene.value.links.push(newLink);
        }
      }
    }

    const linkingBreak = (block: RefinedBlock, slotIndex: number) => {
      const findLink = scene.value.links.find((link: RefinedLink) => {
        return link.toBlock === block.id && link.toSlot === slotIndex;
      });
      if (typeof findLink === 'undefined') return;
      let find_block = scene.value.blocks.find((block: RefinedBlock) => {
        return block.id === findLink.fromBlock;
      });
      if (!find_block) return;
      scene.value.links = scene.value.links.filter((link) => {
        return !(link.toBlock === block.id && link.toSlot === slotIndex);
      });
      block.inputs[slotIndex].active = '';
      linkingStart(find_block, findLink.fromSlot);
    };

    const edit_block = (id: string) => {
      let node = findBlock(id);
      if (!node) return;
      edit_dialog.show = true;
      edit_dialog.block = node;
    };

    const does_testbed_exist = () => {
      return scene.value.blocks.some((block) => block.family === 'testbed');
    };

    const find_testbed_block = () => {
      return scene.value.blocks.find((block) => block.family === 'testbed');
    };

    /*
      TODO
      Algorithm to verify a task tree
      Starting from the testbed block, proceed backwards until we find all controllers and references
      attached to the testbed motors.
      testbed -> link(s) -> controller(s) -> link(s) -> reference(s)
    */

    const drag_handler = {
      dragover_handler: (e: DragEvent) => {
        e.preventDefault();
      },
      drop_handler: (e: DragEvent) => {
        const data = e.dataTransfer?.getData('text/plain');
        if (!data) return;
        const position = getMousePosition(el.value, e);
        const [family, name] = data.split('/');
        switch (family) {
          case 'testbed':
            if (does_testbed_exist()) {
              errorNotification('Only one testbed block is allowed per task');
              return;
            }
        }
        const node = get_node(name, family);
        position.x -= 75 + scene.value.container.center.x;
        position.y -= 70 + scene.value.container.center.y;
        if (node) {
        const block = create_block(node, { id: uuidv4(), position: position, family: family });

        if (block.family === 'testbed') {
          block.data['Duration'] = 30;
          block.data['Frequency'] = 2000;
        }

        scene.value.blocks.push(block);
        }
      }
    };

    return {
      el,
      scene,
      block_options,
      nodeSelected,
      deleteBlock,
      handleMove,
      handleUp,
      handleDown,
      resetView,
      lines,
      linkingStart,
      linkingBreak,
      linkingStop,
      edit_block,
      edit_dialog,
      ...drag_handler,
    };
  },
});
</script>

<style scoped lang="sass">
.container
  margin: 0
  position: relative
  overflow: hidden
  background-size: 20px 20px
  background-color: rgba(0,0,0,0.05)
  background-image: linear-gradient(90deg, rgba(255,255,255,0.4) 1px, transparent 0px),linear-gradient(0deg, rgba(255,255,255,0.4) 1px, transparent 1px)
  svg
    cursor: move
  z-index: 0

.menu
  position: absolute
  top: 15px
  right: 15px
  z-index: 3
</style>
